---
title: margin-trim
slug: Web/CSS/margin-trim
tags:
  - CSS
  - CSS Property
  - Draft
  - Experimental
  - NeedsContent
  - NeedsExample
  - NeedsLiveSample
  - Reference
  - 'recipe:css-property'
---
<p>{{CSSRef}}</p>

<p>The <code>margin-trim</code> property allows the container to trim the margins of its children where they adjoin the container’s edges.</p>

<h2 id="Syntax">Syntax</h2>

<dl>
 <dt><code>none</code></dt>
 <dd>Margins are not trimmed by the container.</dd>
 <dt><code>in-flow</code></dt>
 <dd>
 <p>For in-flow boxes contained by this box, block-axis margins adjacent to the box's edges are truncated to zero.</p>

 <p>It also truncates any margins collapsed with such a margin.</p>
 </dd>
 <dt><code>all</code></dt>
 <dd>Trims the margins of in-flow boxes and floats whose margins coincide with the container's content edge.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<p>Once support is implemented for this property, it will probably work like so:</p>

<p>When you've got a container with some inline children and you want to put a margin between each child but not have it interfere with the spacing at the end of the row, you might do something like this:</p>

<pre class="brush: css notranslate">article {
  background-color: red;
  margin: 20px;
  padding: 20px;
  display: inline-block;
}

article &gt; span {
  background-color: black;
  color: white;
  text-align: center;
  padding: 10px;
  margin-right: 20px;
}</pre>

<p>The problem here is that you'd end up with 20px too much spacing at the right of the row, so you'd maybe do this to fix it:</p>

<pre class="brush: css notranslate">span:last-child {
  margin-right: 0;
}</pre>

<p>It is a pain having to write another rule to achieve this, and it is also not very flexible. Instead, <code>margin-trim</code> could fix it:</p>

<pre class="brush: css notranslate"> article {
  margin-trim: in-flow;
  ...
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Box', '#margin-trim', 'margin-trim')}}</td>
   <td>{{Spec2('CSS4 Box')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("css.properties.margin-trim")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("margin")}}</li>
</ul>
